﻿#include "keyboard.h"
#include <QDebug>
#include <QKeyEvent>
#include "player.h"

CKeyboard    keyboard;

bool CKeyboard::eventFilter(QObject */*object*/, QEvent *event){

    if (event->type() == QEvent::KeyPress)
    {
        QKeyEvent *keyEvent = static_cast<QKeyEvent *>(event);

        if (keyEvent->isAutoRepeat() == false)
        {
            quint32 nativeKey = keyEvent->nativeScanCode();

            switch (nativeKey)
            {
            case 16:    // 'Q' en QWERTY, 'A' en AZERTY
                tempKeys[eTurnLeft] = true;
                break;

            case 17:    // 'W' en QWERTY, 'Z' en AZERTY
                tempKeys[eForward] = true;
                break;

            case 18:    // 'E'
                tempKeys[eTurnRight] = true;
                break;

            case 30:    // 'A' en QWERTY, 'Q' en AZERTY
                tempKeys[eLeft] = true;
                break;

            case 31:    // 'S'
                tempKeys[eBackward] = true;
                break;

            case 32:    // 'D'
                tempKeys[eRight] = true;
                break;

            default:
                break;
            }
        }
        return true;
    }

    return false;
}

void CKeyboard::update()
{
    for (int i = 0; i < eKeyCount; ++i)
    {
        keys[i] = tempKeys[i];
        tempKeys[i] = false;
    }
}
